package com.inca.npbusi.sales.bms_sales_back;

import com.inca.entity.client.pub.CompanyOnClient;
import com.inca.entity.client.pub.LotOnClient;
import com.inca.gsp.service.GSPHelper;
import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.pirce.tools.ExamPriceUtil;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_lot_def_hov.Bms_lot_def_hov;
import java.math.BigDecimal;
import javax.swing.SwingUtilities;

public class Bms_sales_back_detail extends CDetailModel {
   private String a;

   public Bms_sales_back_detail(CFrame var1, CMdeModel var2) {
      super(var1, "销售退货细单", var2);
      this.getDBColumnDisplayInfo("goodsqty1").setDbcolumn(false);
      this.getDBColumnDisplayInfo("goodsuseqty1").setDbcolumn(false);
      this.getDBColumnDisplayInfo("total_line1").setDbcolumn(false);
      this.getDBColumnDisplayInfo("notaxmoney1").setDbcolumn(false);
      this.getDBColumnDisplayInfo("settleqty1").setDbcolumn(false);
      this.getDBColumnDisplayInfo("settlemoney1").setDbcolumn(false);
      this.getDBColumnDisplayInfo("maxbackqty").setDbcolumn(false);
      this.getDBColumnDisplayInfo("sadtlid1").setDbcolumn(false);
   }

   public String getTablename() {
      return "bms_sabk_dtl_v";
   }

   public String getSaveCommandString() {
      return null;
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      if (DecimalHelper.toDec(this.getItemValue(var1, "goodsuseqty1")).compareTo(new BigDecimal("0")) <= 0) {
         this.infoMessage("提示", "使用单位数量不可以为空和零");
         return -1;
      } else if (DecimalHelper.toDec(this.getItemValue(var1, "goodsqty1")).compareTo(new BigDecimal("0")) <= 0) {
         this.infoMessage("提示", "使用单位数量必须大于零");
         return -1;
      } else if (DecimalHelper.toDec(this.getItemValue(var1, "unitprice")).compareTo(new BigDecimal("0")) < 0) {
         this.infoMessage("提示", "退货单价不能小于零");
         return -1;
      } else {
         String var3 = ((Bms_sales_back_mde)this.mdemodel).getApvalue("是否必须勾原单");
         String var4 = this.getItemValue(var1, "sadtlid1");
         if (var3.equals("1") && ("".equals(var4) || var4 == null)) {
            this.infoMessage("提示", "必须勾原单生成销退！");
            return -1;
         } else {
            String var5;
            if (!"".equals(this.getItemValue(var1, "sadtlid1"))) {
               var3 = this.getItemValue(var1, "goodsuseqty1");
               if ("".equals(var3)) {
                  this.errorMessage("错误", "使用单位数量不能为空!");
                  return -1;
               }

               var4 = this.getItemValue(var1, "goodsuseunit");
               if ("".equals(var4)) {
                  this.errorMessage("错误", "使用单位不能为空!");
                  return -1;
               }

               var5 = this.getItemValue(var1, "goodsqty1");
               var3 = this.getItemValue(var1, "maxbackqty");
               if (DecimalHelper.toDec(var5).compareTo(DecimalHelper.toDec(var3)) > 0) {
                  this.infoMessage("提示", "退货数量不能大于可退数量");
                  return -1;
               }
            }

            if ((var3 = this.getItemValue(var1, "posid")) != null && !var3.equals("") && !var3.equals("0")) {
               DBTableModel var7 = null;
               RemotesqlHelper var8 = new RemotesqlHelper();
               var3 = "select * from bms_storer_pos where posid = " + var3;

               try {
                  var7 = var8.doSelect(var3, 0, 1);
               } catch (Exception var6) {
                  var6.printStackTrace();
               }

               if (var7.getRowCount() <= 0) {
                  return -1;
               }

               var3 = var7.getItemValue(0, "goodsunitflag");
               if ("1".equals(var3)) {
                  var3 = this.getItemValue(var1, "goodsqty");
                  var4 = this.getItemValue(var1, "packsize");
                  if (DecimalHelper.toDec(var3).remainder(DecimalHelper.toDec(var4)).compareTo(new BigDecimal("0")) != 0) {
                     this.infoMessage("提示", "第" + (var1 + 1) + "行细单，整件货位的数量必须是整件！");
                     return -1;
                  }
               }
            }

            var4 = this.getItemValue(var1, "batchflag");
            if (!"1".equals(var4) || (var5 = this.getItemValue(var1, "batchprice")) != null && !"".equals(var5)) {
               return super.on_checkrow(var1, var2);
            } else {
               this.infoMessage("提示", "制定批次价，数据项【含税批次价】必填！");
               return -1;
            }
         }
      }
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "settleflag", "0");
      this.setItemValue(var1, "stioflag", "0");
      this.setItemValue(var1, "skioflag", "0");
      this.setItemValue(var1, "saoutflag", "0");
      this.setItemValue(var1, "correctflag", "0");
      this.setItemValue(var1, "goodsstatus", ((Bms_sales_back_mde)this.mdemodel).getApvalue("缺省货品状态"));
      return super.on_new(var1);
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      String var4;
      String var5;
      String var7;
      if ("lotno".equals(var2)) {
         var4 = this.getItemValue(var1, "goodsid");
         if (var3 == null || "".equals(var3) || var3.length() == 0) {
            this.setItemValue(var1, "lotid", "");
            this.setItemValue(var1, "proddate", "");
            this.setItemValue(var1, "lotinvaliddate", "");
            this.setItemValue(var1, "approvedocno", "");
            this.setItemValue(var1, "killlotno", "");
            this.setItemValue(var1, "killdate", "");
            this.setItemValue(var1, "printset", "");
            this.setItemValue(var1, "checkno", "");
            this.setItemValue(var1, "synchronizedapprovetogoods", "");
            super.on_itemvaluechange(var1, var2, var3);
            return;
         }

         if (var4 == null || "".equals(var4)) {
            this.infoMessage("提示", "请先选择货品");
            this.setItemValue(var1, "lotno", "");
            super.on_itemvaluechange(var1, var2, var3);
            return;
         }

         var5 = this.getBatchNoCount(var3);
         this.setItemValue(var1, "lotid", "");
         this.setItemValue(var1, "proddate", "");
         this.setItemValue(var1, "invaliddate", "");
         this.setItemValue(var1, "approvedocno", "");
         this.setItemValue(var1, "killlotno", "");
         this.setItemValue(var1, "killdate", "");
         this.setItemValue(var1, "printset", "");
         this.setItemValue(var1, "checkno", "");
         this.setItemValue(var1, "synchronizedapprovetogoods", "");
         if ("0".equals(var5)) {
            LotOnClient var6;
            (var6 = new LotOnClient((String)null, var3, var4)).autoGenProdAndInvalidDate();
            this.setItemValue(var1, "proddate", var6.getProdDate());
            this.setItemValue(var1, "invaliddate", var6.getInvalidDate());
            this.setItemValue(var1, "killdate", NpbusiDBHelper.getSysdate());
            this.setItemValue(var1, "lotid", "");
         } else {
            Bms_lot_def_hov var19 = new Bms_lot_def_hov();
            var7 = null;
            if (var3 != null && !var3.trim().isEmpty()) {
               var7 = " and lotno like '" + var3 + "'";
            } else {
               var7 = " and trim(lotno) is null";
            }

            DBTableModel var21;
            if ((var21 = var19.showDialog(this.frame, "选择批号", "", "", "goodsid = " + var4 + var7)) == null) {
               this.setFocus("lotno");
               return;
            }

            this.setItemValue(var1, "lotno", var21.getItemValue(0, "lotno"));
            this.setItemValue(var1, "lotid", var21.getItemValue(0, "lotid"));
            this.setItemValue(var1, "invaliddate", var21.getItemValue(0, "invaliddate"));
            this.setItemValue(var1, "proddate", var21.getItemValue(0, "proddate"));
            this.setItemValue(var1, "approvedocno", var21.getItemValue(0, "approvedocno"));
            this.setItemValue(var1, "checkno", var21.getItemValue(0, "checkno"));
            this.setItemValue(var1, "killdate", var21.getItemValue(0, "killdate"));
            this.setItemValue(var1, "killlotno", var21.getItemValue(0, "killlotno"));
            this.setItemValue(var1, "printset", var21.getItemValue(0, "printset"));
         }
      }

      var4 = ClientUserManager.getCurrentUser().getEntryid();
      var5 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
      String var20 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "salesdeptid");
      var7 = null;
      var7 = null;
      String var8 = null;
      String var9;
      DBTableModel var10;
      if (!"goodsid".equals(var2) || "".equals(var3) || this.a != null && var3.equals(this.a)) {
         String var25;
         if ("goodsuseqty1".equals(var2) && !"".equals(var3)) {
            if ((var8 = this.getItemValue(var1, "goodsuseunit")).indexOf("(") == -1) {
               var9 = "1";
            } else {
               var9 = var8.substring(var8.indexOf("(") + 1, var8.indexOf(")"));
            }

            var25 = DecimalHelper.multi(var3, var9, 6);
            this.setItemValue(var1, "goodsqty1", var25);
            this.setItemValue(var1, "goodsqty", DecimalHelper.multi("-1", var25, 6));
            this.setItemValue(var1, "goodsuseqty", DecimalHelper.multi(var3, "-1", 6));
            this.a(var1);
            var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodsqty1"), this.getItemValue(var1, "unitprice"), this.getItemValue(var1, "examprice"));
            this.setItemValue(var1, "examprofit", var8);
         } else if ("goodsuseqty1".equals(var2) && "".equals(var3)) {
            this.setItemValue(var1, "goodsqty1", "0");
            this.setItemValue(var1, "goodsqty", "0");
            this.a(var1);
         } else if ("goodsuseunit".equals(var2) && !"".equals(var3)) {
            var8 = this.getItemValue(var1, "goodsuseqty1");
            if (var3.indexOf("(") == -1) {
               var9 = "1";
            } else {
               var9 = var3.substring(var3.indexOf("(") + 1, var3.indexOf(")"));
            }

            var25 = DecimalHelper.multi(var8, var9, 6);
            this.setItemValue(var1, "goodsqty1", var25);
            this.setItemValue(var1, "goodsqty", DecimalHelper.multi("-1", var25, 6));
            this.a(var1);
            var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodsqty1"), this.getItemValue(var1, "unitprice"), this.getItemValue(var1, "examprice"));
            this.setItemValue(var1, "examprofit", var8);
         } else if (var2.equals("unitprice")) {
            this.a(var1);
            var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodsqty1"), this.getItemValue(var1, "unitprice"), this.getItemValue(var1, "examprice"));
            this.setItemValue(var1, "examprofit", var8);
         } else if ("sadtlid1".equals(var2) && !"".equals(var3)) {
            DBTableModel var23 = null;
            var9 = " select a.batchid,a.lotid,a.posid,a.goodsstatusid from bms_st_io_dtl a,bms_st_io_doc b where a.inoutid = b.inoutid and b.sourcetable = 2 and b.sourceid =" + var3 + " ";
            RemotesqlHelper var24 = new RemotesqlHelper();

            try {
               var23 = var24.doSelect(var9, 0, 1);
            } catch (Exception var14) {
               var14.printStackTrace();
            }

            if (var23 != null && var23.getRowCount() > 0) {
               this.setItemValue(var1, "batchid", var23.getItemValue(0, "batchid"));
               this.setItemValue(var1, "posid", var23.getItemValue(0, "posid"));
               this.setItemValue(var1, "goodsstatusid", var23.getItemValue(0, "goodsstatusid"));
               this.setItemValue(var1, "lotid", var23.getItemValue(0, "lotid"));
            }
         } else if ("settleqty1".equals(var2)) {
            var8 = this.getItemValue(var1, "settleqty1");
            this.setItemValue(var1, "settleqty", DecimalHelper.multi("-1", var8, 6));
         } else if ("settlemoney1".equals(var2)) {
            var8 = this.getItemValue(var1, "settlemoney1");
            this.setItemValue(var1, "settlemoney", DecimalHelper.multi("-1", var8, 2));
         } else if ("storageid".equals(var2)) {
            this.setItemValue(var1, "posno", "");
         } else if ("batchid".equals(var2) && !"".equals(var3)) {
            try {
               var7 = this.getItemValue(var1, "batchid");
               var8 = "select p.wholeresaleflag from pub_price_type p,bms_examine_prtype_def e  where p.priceid = e.exampriceid  and e.companyid = " + var20;
               RemotesqlHelper var22;
               if ((var10 = (var22 = new RemotesqlHelper()).doSelect(var8, 0, 1)) == null || var10.getRowCount() == 0) {
                  return;
               }

               if ("9".equals(var10.getItemValue(0, "wholeresaleflag")) && !"1".equals(this.getItemValue(var1, "batchflag"))) {
                  var7 = "select b.unitprice from bms_batch_def b where b.batchid = " + var7;
                  System.err.println("batchSql-" + var7);
                  if ((var10 = var22.doSelect(var7, 0, 1)) != null && var10.getRowCount() != 0) {
                     var7 = var10.getItemValue(0, "unitprice");
                     this.setItemValue(var1, "examprice", var7);
                     var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodsqty1"), this.getItemValue(var1, "unitprice"), this.getItemValue(var1, "examprice"));
                     this.setItemValue(var1, "examprofit", var8);
                  }
               }
            } catch (Exception var16) {
               this.errorMessage("错误", "获取考核价失败");
               var16.printStackTrace();
               return;
            }
         } else if (!"batchflag".equals(var2)) {
            if ("batchprice".equals(var2) && !"".equals(var3) && "1".equals(this.getItemValue(0, "batchflag"))) {
               try {
                  this.getItemValue(var1, "batchid");
                  var8 = "select p.wholeresaleflag from pub_price_type p,bms_examine_prtype_def e  where p.priceid = e.exampriceid  and e.companyid = " + var20;
                  if ((var10 = (new RemotesqlHelper()).doSelect(var8, 0, 1)) == null || var10.getRowCount() == 0) {
                     return;
                  }

                  if ("9".equals(var10.getItemValue(0, "wholeresaleflag"))) {
                     var7 = this.getItemValue(var1, "batchprice");
                     this.setItemValue(var1, "examprice", var7);
                     var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodsqty1"), this.getItemValue(var1, "unitprice"), this.getItemValue(var1, "examprice"));
                     this.setItemValue(var1, "examprofit", var8);
                  }
               } catch (Exception var17) {
                  this.errorMessage("错误", "获取考核价失败");
                  var17.printStackTrace();
                  return;
               }
            }
         } else {
            if ("1".equals(this.getItemValue(0, "batchflag"))) {
               try {
                  this.getItemValue(var1, "batchid");
                  var8 = "select p.wholeresaleflag from pub_price_type p,bms_examine_prtype_def e  where p.priceid = e.exampriceid  and e.companyid = " + var20;
                  if ((var10 = (new RemotesqlHelper()).doSelect(var8, 0, 1)) == null || var10.getRowCount() == 0) {
                     return;
                  }

                  if ("9".equals(var10.getItemValue(0, "wholeresaleflag"))) {
                     var7 = this.getItemValue(var1, "batchprice");
                     var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodsqty1"), this.getItemValue(var1, "unitprice"), var7);
                     this.setItemValue(var1, "examprice", var7);
                     this.setItemValue(var1, "examprofit", var8);
                  }
               } catch (Exception var18) {
                  this.errorMessage("错误", "获取考核价失败");
                  var18.printStackTrace();
                  return;
               }
            }

            if ("0".equals(this.getItemValue(0, "batchflag"))) {
               this.on_itemvaluechange(var1, "batchid", this.getItemValue(var1, "batchid"));
            }
         }

         super.on_itemvaluechange(var1, var2, var3);
      } else {
         this.a = var3;
         this.setItemValue(var1, "batchid", "");
         this.setItemValue(var1, "batchno", "");
         var8 = "";
         var9 = "";
         var10 = null;
         var7 = "select price from pub_price_type a,bms_entry_goods_price b where a.priceid=b.priceid and a.wholeresaleflag=1 and b.goodsid=" + var3 + " and b.entryid=" + var4;
         RemotesqlHelper var11 = new RemotesqlHelper();

         try {
            var10 = var11.doSelect(var7, 0, 1);
         } catch (Exception var13) {
            var13.printStackTrace();
         }

         if (var10 != null && var10.getRowCount() > 0) {
            var8 = var10.getItemValue(0, "price");
         }

         var7 = "select price from pub_price_type a,bms_entry_goods_price b where a.priceid=b.priceid and a.wholeresaleflag=13 and b.goodsid=" + var3 + " and b.entryid=" + var4;

         try {
            var10 = var11.doSelect(var7, 0, 1);
         } catch (Exception var12) {
            var12.printStackTrace();
         }

         if (var10 != null && var10.getRowCount() > 0) {
            var9 = var10.getItemValue(0, "price");
         }

         this.setItemValue(var1, "wholesaleprice", var8);
         this.setItemValue(var1, "resaleprice", var9);

         try {
            if (!"".equals(this.getItemValue(var1, "salesdtlid"))) {
               return;
            }

            var7 = ExamPriceUtil.getExamPrice(ExamPriceUtil.BMS, var5, var20, this.getItemValue(var1, "goodsid"));
            var8 = ExamPriceUtil.getExamProfit(this.getItemValue(var1, "goodqty1"), this.getItemValue(var1, "unitprice"), var7);
         } catch (Exception var15) {
            this.errorMessage("错误", "获取考核价失败");
            var15.printStackTrace();
            return;
         }

         this.setItemValue(var1, "examprice", var7);
         this.setItemValue(var1, "examprofit", var8);
         this.commitEdit();
         super.on_itemvaluechange(var1, var2, var3);
         var7 = this.getItemValue(this.getRow(), "goodsunit");
         this.setItemValue(this.getRow(), "goodsuseunit", var7);
      }
   }

   public boolean canInvokehov(String var1) {
      String var2;
      if ("batchno".equals(var1)) {
         var2 = this.getItemValue(this.getRow(), "goodsid");
         System.err.print(var2);
         if (var2 == null || "".equals(var2)) {
            this.infoMessage("提示", "请先选择货品再选择批号");
            return false;
         }
      }

      if (!var1.equals("lotno") || (var2 = this.getItemValue(this.mdemodel.getDetailModel().getRow(), "goodsid")) != null && !var2.equals("")) {
         return !var1.equals("posno") || (var2 = this.getItemValue(this.mdemodel.getDetailModel().getRow(), "storageid")) != null && !var2.equals("") ? super.canInvokehov(var1) : false;
      } else {
         return false;
      }
   }

   public int on_hov(int var1, String var2, DBTableModel var3) {
      super.on_hov(var1, var2, var3);
      RemotesqlHelper var4 = null;
      var4 = new RemotesqlHelper();
      if (var2.equals("opcode")) {
         String var5 = var3.getItemValue(0, "goodsid");
         String var6 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
         String var7 = ClientUserManager.getCurrentUser().getEntryid();
         var5 = "select * from bms_sa_goods_price_v a,PUB_COMPANY_TO_definfo_v b  where  (a.customid is null or a.customid =" + var6 + ")  and a.goodsid =" + var5 + "and a.entryid=" + var7 + " and a.priceid=b.priceid(+) and b.companyid=" + var6;

         try {
            DBTableModel var9;
            if ((var9 = var4.doSelect(var5, 0, 1)) != null && var9.getRowCount() > 0) {
               this.setItemValue(this.getRow(), "priceopcode", var9.getItemValue(0, "priceopcode"));
               this.setItemValue(this.getRow(), "pricename", var9.getItemValue(0, "pricename"));
               this.setItemValue(this.getRow(), "unitprice", var9.getItemValue(0, "price"));
               this.setItemValue(this.getRow(), "priceid", var9.getItemValue(0, "priceid"));
            } else {
               this.setItemValue(this.getRow(), "priceopcode", "");
               this.setItemValue(this.getRow(), "pricename", "");
               this.setItemValue(this.getRow(), "unitprice", "");
               this.setItemValue(this.getRow(), "priceid", "");
               this.infoMessage("提示", "货品没有定义默认价格，请先定义价格。");
            }
         } catch (Exception var8) {
            var8.printStackTrace();
         }

         this.setItemValue(var1, "lotno", "");
         this.setItemValue(var1, "lotid", "");
         this.setItemValue(var1, "invaliddate", "");
      }

      return super.on_hov(var1, var2, var3);
   }

   private String a() {
      int var1 = this.mdemodel.getMasterModel().getRow();
      String var2 = ((Bms_sales_back_mde)this.mdemodel).getEntryid();
      String var5 = this.mdemodel.getMasterModel().getItemValue(var1, "customid");
      CompanyOnClient var6;
      (var6 = new CompanyOnClient(var5)).setCompanyType(2);
      String var3 = " and " + GSPHelper.getGoodsOtherWheresOnHov(var2, "pub_goods_dtl_hov_v", "goodsid", true, false);

      try {
         var3 = var3 + var6.sendLimitCheck("3", var2);
         return var3;
      } catch (Exception var4) {
         this.errorMessage("获取供应商经营范围、类别时错误", var4.getMessage());
         return "";
      }
   }

   public String getHovOtherWheres(int var1, String var2) {
      if ("opcode".equals(var2)) {
         var2 = this.a();
         return "nvl(accflag,0)<>5 " + var2;
      } else if ("batchno".equals(var2)) {
         return " goodsid = " + this.getItemValue(var1, "goodsid");
      } else if (var2.equals("lotno")) {
         if ((var2 = this.getItemValue(var1, "goodsid")) != null && !var2.equals("")) {
            return "goodsid=" + var2;
         } else {
            this.infoMessage("提示", "请先录入货品!");
            return "1=2";
         }
      } else if (var2.equals("posno")) {
         var2 = this.getItemValue(var1, "storageid");
         return "sthouseid in (select sthouseid from bms_st_storehouse where storerid=(select  phystoreid from bms_st_def where storageid=" + var2 + "))";
      } else {
         String var3;
         if (var2.equals("priceopcode")) {
            var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "customid");
            var3 = this.getItemValue(var1, "goodsid");
            return "(customid is null or customid = " + var2 + ") and goodsid = " + var3 + " and entryid=" + ((Bms_sales_back_mde)this.mdemodel).getEntryid();
         } else if ("storageopcode".equals(var2)) {
            var3 = ((Bms_sales_back_mde)this.mdemodel).getEntryid();
            return " procflag = 2 and  exists (select storageid from bms_st_def where entryid =  " + var3 + " and  bms_st_def.storageid=bms_st_def_v.storageid ) ";
         } else if ("".equals(var2)) {
            var2 = this.getItemValue(this.getRow(), "goodsid");
            var3 = this.getItemValue(this.getRow(), "goodsdtlid");
            return "(goodsid=" + var2 + " and goodsdtlid=" + var3 + ") or batchid = 0";
         } else {
            return super.getHovOtherWheres(var1, var2);
         }
      }
   }

   private void a(int var1) {
      String var2 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "exchange");
      String var3 = this.getItemValue(var1, "unitprice");
      String var4 = this.getItemValue(var1, "goodsqty1");
      String var5 = this.getItemValue(var1, "taxrate");
      if (!var2.equals("") && !var2.equals("0") && !var2.equals("0.0000")) {
         var3 = DecimalHelper.multi(var3, var2, 10);
      }

      var3 = DecimalHelper.divide(var2 = DecimalHelper.multi(var3, var4, 2), DecimalHelper.add("1", var5, 10), 2);
      this.setItemValue(var1, "total_line1", var2);
      this.setItemValue(var1, "total_line", DecimalHelper.multi("-1", var2, 2));
      this.setItemValue(var1, "notaxmoney1", var3);
      this.setItemValue(var1, "notaxmoney", DecimalHelper.multi("-1", var3, 2));
   }

   public void gensabackdtl(int[] var1, DBTableModel var2) {
      DBTableModel var3 = this.getDBtableModel();
      int var4 = var1.length;

      for(int var5 = 0; var5 < var4; ++var5) {
         String var6 = var2.getItemValue(var1[var5], "salesid");
         if ((var6 = this.a(var6)) != null && var6.length() > 0) {
            this.infoMessage("提示", "原销售总单附带赠品信息如下：\n" + var6);
         }

         var6 = DecimalHelper.sub(var2.getItemValue(var1[var5], "goodsqty"), var2.getItemValue(var1[var5], "backQty"), 6);
         int var7 = var3.getRowCount();
         var3.appendRow();
         var3.setItemValue(var7, "storagename", var2.getItemValue(var1[var5], "storagename"));
         var3.setItemValue(var7, "opcode", var2.getItemValue(var1[var5], "opcode"));
         var3.setItemValue(var7, "goodsno", var2.getItemValue(var1[var5], "goodsno"));
         var3.setItemValue(var7, "goodsname", var2.getItemValue(var1[var5], "goodsname"));
         var3.setItemValue(var7, "currencyname", var2.getItemValue(var1[var5], "currencyname"));
         var3.setItemValue(var7, "goodsunit", var2.getItemValue(var1[var5], "goodsunit"));
         var3.setItemValue(var7, "goodsuseunit", var2.getItemValue(var1[var5], "goodsunit"));
         var3.setItemValue(var7, "goodstype", var2.getItemValue(var1[var5], "goodstype"));
         var3.setItemValue(var7, "prodarea", var2.getItemValue(var1[var5], "prodarea"));
         var3.setItemValue(var7, "factoryname", var2.getItemValue(var1[var5], "factoryname"));
         var3.setItemValue(var7, "packname", var2.getItemValue(var1[var5], "packname"));
         var3.setItemValue(var7, "packsize", var2.getItemValue(var1[var5], "packsize"));
         var3.setItemValue(var7, "taxrate", var2.getItemValue(var1[var5], "taxrate"));
         var3.setItemValue(var7, "maxbackqty", var6);
         var3.setItemValue(var7, "goodsqty1", var6);
         var3.setItemValue(var7, "goodsqty", DecimalHelper.multi(var6, "-1", 6));
         var3.setItemValue(var7, "goodsuseunit", var2.getItemValue(var1[var5], "goodsuseunit"));
         var3.setItemValue(var7, "goodsuseqty1", var6);
         var3.setItemValue(var7, "goodsuseqty", DecimalHelper.multi(var6, "-1", 6));
         var3.setItemValue(var7, "priceopcode", var2.getItemValue(var1[var5], "priceopcode"));
         var3.setItemValue(var7, "pricename", var2.getItemValue(var1[var5], "pricename"));
         var3.setItemValue(var7, "unitprice", var2.getItemValue(var1[var5], "unitprice"));
         var3.setItemValue(var7, "total_line1", var2.getItemValue(var1[var5], "total_line"));
         var3.setItemValue(var7, "total_line", DecimalHelper.multi(var2.getItemValue(var1[var5], "total_line"), "-1", 2));
         var3.setItemValue(var7, "discount", var2.getItemValue(var1[var5], "discount"));
         var3.setItemValue(var7, "notaxmoney1", var2.getItemValue(var1[var5], "notaxmoney"));
         var3.setItemValue(var7, "notaxmoney", DecimalHelper.multi(var2.getItemValue(var1[var5], "notaxmoney"), "-1", 2));
         var3.setItemValue(var7, "timepricename", var2.getItemValue(var1[var5], "timepricename"));
         var3.setItemValue(var7, "timeprice", var2.getItemValue(var1[var5], "timeprice"));
         var3.setItemValue(var7, "wholesaleprice", var2.getItemValue(var1[var5], "wholesaleprice"));
         var3.setItemValue(var7, "resaleprice", var2.getItemValue(var1[var5], "resaleprice"));
         var3.setItemValue(var7, "lastpricename", var2.getItemValue(var1[var5], "lastpricename"));
         var3.setItemValue(var7, "lastunitprice", var2.getItemValue(var1[var5], "lastunitprice"));
         var3.setItemValue(var7, "allowbackflag", var2.getItemValue(var1[var5], "allowbackflag"));
         var3.setItemValue(var7, "batchno", var2.getItemValue(var1[var5], "batchno"));
         var3.setItemValue(var7, "lotno", var2.getItemValue(var1[var5], "lotno"));
         var3.setItemValue(var7, "invaliddate", var2.getItemValue(var1[var5], "invaliddate"));
         var3.setItemValue(var7, "posno", var2.getItemValue(var1[var5], "posno"));
         var3.setItemValue(var7, "goodsstatusid", var2.getItemValue(var1[var5], "goodsstatusid"));
         var3.setItemValue(var7, "dtlmemo", var2.getItemValue(var1[var5], "dtlmemo"));
         var3.setItemValue(var7, "correctflag", var2.getItemValue(var1[var5], "correctflag"));
         var3.setItemValue(var7, "stioflag", "0");
         var3.setItemValue(var7, "lowerflag", var2.getItemValue(var1[var5], "lowerflag"));
         var3.setItemValue(var7, "settleflag", "0");
         var3.setItemValue(var7, "sadtlid1", var2.getItemValue(var1[var5], "salesdtlid"));
         var3.setItemValue(var7, "goodsid", var2.getItemValue(var1[var5], "goodsid"));
         this.a = var2.getItemValue(var1[var5], "goodsid");
         var3.setItemValue(var7, "factoryid", var2.getItemValue(var1[var5], "factoryid"));
         var3.setItemValue(var7, "goodsdtlid", var2.getItemValue(var1[var5], "goodsdtlid"));
         var3.setItemValue(var7, "priceid", var2.getItemValue(var1[var5], "priceid"));
         var3.setItemValue(var7, "timepriceid", var2.getItemValue(var1[var5], "timepriceid"));
         var3.setItemValue(var7, "storageid", var2.getItemValue(var1[var5], "storageid"));
         var3.setItemValue(var7, "storageopcode", var2.getItemValue(var1[var5], "storageopcode"));
         var3.setItemValue(var7, "lastpriceid", var2.getItemValue(var1[var5], "lastpriceid"));
         var3.setItemValue(var7, "batchid", var2.getItemValue(var1[var5], "batchid"));
         var3.setItemValue(var7, "lotid", var2.getItemValue(var1[var5], "lotid"));
         var3.setItemValue(var7, "posid", var2.getItemValue(var1[var5], "posid"));
         var3.setItemValue(var7, "oldsadate", var2.getItemValue(var1[var5], "credate"));
         var3.setItemValue(var7, "oldsaqty", var2.getItemValue(var1[var5], "goodsqty"));
         var3.setItemValue(var7, "examprice", var2.getItemValue(var1[var5], "examprice"));
         var3.setItemValue(var7, "examprofit", var2.getItemValue(var1[var5], "examprofit"));
         this.on_itemvaluechange(var7, "sadtlid1", var2.getItemValue(var1[var5], "salesdtlid"));
      }

      this.tableChanged();
   }

   private String a(String var1) {
      ClientRequest var2;
      (var2 = new ClientRequest()).addCommand(new StringCommand("销售退货单管理.查询原销售单赠品信息"));
      var2.addCommand(new StringCommand(var1));
      StringCommand var3 = null;

      try {
         ServerResponse var5;
         if ((var3 = (StringCommand)(var5 = SendHelper.sendRequest(var2)).commandAt(0)).getString().startsWith("+OK")) {
            return ((StringCommand)var5.commandAt(1)).getString();
         } else {
            this.infoMessage("提示", "查询原销售单赠品信息时出错:" + var3.getString());
            return null;
         }
      } catch (Exception var4) {
         var4.printStackTrace();
         this.infoMessage("提示", "查询原销售单赠品信息时出错:" + var4.getMessage());
         return null;
      }
   }

   protected String getBatchNoCount(String var1) {
      int var2 = this.mdemodel.getDetailModel().getRow();
      String var6 = this.mdemodel.getDetailModel().getItemValue(var2, "goodsid");
      String var3 = "";
      DBTableModel var4 = null;
      var6 = "select count(1) from bms_lot_def where goodsid=" + var6;
      if (var1 != null && !var1.trim().isEmpty()) {
         var1 = " and lotno like '" + var1 + "'";
      } else {
         var1 = " and trim(lotno) is null";
      }

      var6 = var6 + var1;
      RemotesqlHelper var7 = new RemotesqlHelper();

      try {
         var4 = var7.doSelect(var6, 0, 1);
      } catch (Exception var5) {
         var5.printStackTrace();
      }

      if (var4 != null && var4.getRowCount() > 0) {
         var3 = var4.getItemValue(0, 0);
      }

      return var3;
   }

   protected String getEditablecolumns(int var1) {
      int var2 = this.mdemodel.getMasterModel().getRow();
      String var4 = this.mdemodel.getMasterModel().getItemValue(var2, "usestatus");
      if ("1".equals(var4)) {
         return "";
      } else if (this.getRowCount() > 0 && var1 < this.getRowCount()) {
         var4 = this.getItemValue(var1, "sadtlid1");
         String var3;
         if (!"".equals(var4)) {
            return (var3 = this.getItemValue(var1, "batchid")) != null && !"".equals(var3) ? "storageopcode,goodsuseqty1,goodsuseunit,backwhyid" : "storageopcode,goodsuseqty1,goodsuseunit,backwhyid,batchflag,batchprice";
         } else if ((var3 = this.mdemodel.getDetailModel().getItemValue(var1, "lotid")) != null && !"".equals(var3)) {
            return "storageopcode,opcode,priceopcode,unitprice,goodsuseunit,goodsuseqty1,backwhyid,lotno,batchno,batchflag,batchprice,posno,goodsstatusid,dtlmemo";
         } else {
            var3 = ((Bms_sales_back_mde)this.mdemodel).getApvalue("禁止生成新批号");
            return "1".equals(var3) ? "storageopcode,opcode,priceopcode,unitprice,goodsuseunit,goodsuseqty1,backwhyid,lotno,batchno,batchflag,batchprice,posno,goodsstatusid,dtlmemo" : "storageopcode,opcode,priceopcode,unitprice,goodsuseunit,goodsuseqty1,backwhyid,lotno,batchno,batchflag,batchprice,posno,goodsstatusid,dtlmemo,proddate,invaliddate,checkno,approvedocno,killlotno,killdate,printset,synchronizedapprovetogoods";
         }
      } else {
         return super.getEditablecolumns(var1);
      }
   }

   protected void on_retrieved() {
      int var1 = this.getRowCount();

      for(int var2 = 0; var2 < var1; ++var2) {
         String var3 = this.getItemValue(var2, "goodsqty");
         this.setItemValue(var2, "goodsqty1", DecimalHelper.multi("-1", var3, 6));
         var3 = this.getItemValue(var2, "goodsuseqty");
         this.setItemValue(var2, "goodsuseqty1", DecimalHelper.multi("-1", var3, 6));
         var3 = this.getItemValue(var2, "total_line");
         this.setItemValue(var2, "total_line1", DecimalHelper.multi("-1", var3, 2));
         var3 = this.getItemValue(var2, "notaxmoney");
         this.setItemValue(var2, "notaxmoney1", DecimalHelper.multi("-1", var3, 2));
         var3 = this.getItemValue(var2, "settleqty");
         this.setItemValue(var2, "settleqty1", DecimalHelper.multi("-1", var3, 6));
         var3 = this.getItemValue(var2, "settlemoney");
         this.setItemValue(var2, "settlemoney1", DecimalHelper.multi("-1", var3, 2));
         this.getSumdbmodel().fireDatachanged();
      }

      super.on_retrieved();
   }

   protected int on_beforemodify(int var1) {
      if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
         return -1;
      } else {
         this.setFocus("storageopcode");
         return super.on_beforemodify(var1);
      }
   }

   public void on_doubleclick(final int var1, final int var2) {
      if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
         this.infoMessage("提示", "总单为删除状态，不允许修改！");
      } else {
         this.setFocus("storageopcode");
         super.on_doubleclick(var1, var2);
         var2 = this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow());
         final int var3 = this.mdemodel.getDetailModel().getdbStatus(this.mdemodel.getDetailModel().getRow());
         SwingUtilities.invokeLater(new Runnable() {
            public final void run() {
               String var1x = Bms_sales_back_detail.this.getItemValue(var1, "goodsid");
               Bms_sales_back_detail.this.on_itemvaluechange(var1, "goodsid", var1x);
               Bms_sales_back_detail.this.mdemodel.getMasterModel().setdbStatus(Bms_sales_back_detail.this.mdemodel.getMasterModel().getRow(), var2);
               Bms_sales_back_detail.this.mdemodel.getDetailModel().setdbStatus(Bms_sales_back_detail.this.mdemodel.getDetailModel().getRow(), var3);
            }
         });
      }
   }

   protected int on_beforeNew() {
      if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
         this.infoMessage("提示", "总单为删除状态，不允许新增！");
         return -1;
      } else if (((Bms_sales_back_mde)this.mdemodel).getApvalue("是否必须勾原单").equals("1")) {
         this.infoMessage("提示", "必须勾原单生成销退！");
         return -1;
      } else if (this.mdemodel.getMasterModel().getdbStatus(this.mdemodel.getMasterModel().getRow()) == 3) {
         this.infoMessage("提示!", "总单为删除状态不能新增细单!");
         return -1;
      } else {
         return super.on_beforeNew();
      }
   }
}
